% create line in matrix data matline3(xyarea(x,y),x1,y1,x2,y2,f,d)
% copyright 2004 gerox(c) http://www.gerox.com
%{
img=zeros(100,100);
x=1:100;y=abs(100*sin(x/100*2*pi));
img=matline3(img,y(1:end-1),x(1:end-1),y(2:end),x(2:end),1,2);
imshow(img)
%}
function xyarea = matline3(xyarea,xx1,yy1,xx2,yy2,f,d)
if(nargin == 5), f = 1;d = 3;end
if(nargin == 6), d = 3;end
xx1=round(xx1(:));yy1=round(yy1(:));
xx2=round(xx2(:));yy2=round(yy2(:));
for ii=1:length(xx1)
	x1=xx1(ii);x2=xx2(ii);y1=yy1(ii);y2=yy2(ii);
	for i=1:length(x1)
		xysize = size(xyarea)-d;
		dx = abs(x2(i)-x1(i));
		dy = abs(y2(i)-y1(i));
		if(dx > dy),
			if(x1(i) > x2(i)),
				step =sign((y1(i) > y2(i))-0.5);
				s=x1(i);x1(i)=x2(i);x2(i)=s;y1(i)=y2(i);
			else step = sign((y1(i) < y2(i)) -0.5);end
			if [xysize >= [x1(i),y1(i)],[x1(i),y1(i)] > d], xyarea(x1(i)+(-d:d),y1(i)+(-d:d)) = f;end
			s = floor(dx / 2);
			while (x1(i) <= x2(i))
				x1(i) = x1(i) + 1;
				s = s - dy;
				if s < 0
					s = s + dx;
					y1 = y1 + step;
				end
				if [xysize >= [x1(i),y1(i)],[x1(i),y1(i)] > d],xyarea(x1(i)+(-d:d),y1(i)+(-d:d)) = f;end
			end
		else 
			if(y1(i) > y2(i)) 
				step =sign((x1(i) > x2(i))-0.5);
				s=y1(i);y1(i)=y2(i);y2(i)=s;x1(i)=x2(i);
			else step = sign((x1(i)<x2(i))-0.5);end
			if [xysize >= [x1(i),y1(i)],[x1(i),y1(i)] > d], xyarea(x1(i)+(-d:d),y1(i)+(-d:d)) = f;end
			s = floor(dy / 2);
			while (y1(i) <= y2(i))
				y1(i) = y1(i) + 1;
				s = s - dx;
				if s < 0
					s = s + dy;
					x1(i) = x1(i) + step;
				end
				if [xysize >= [x1(i),y1(i)],[x1(i),y1(i)] > d],xyarea(x1(i)+(-d:d),y1(i)+(-d:d)) = f;end
			end
		end
	end
end
