function tukubaremap(xyzdata,data,img,imgdata,filename0, pathname0,filename1,pathname1,remapmode,orgdate)
t=[0,cumsum(sqrt(sum((xyzdata(1:end-1,1:2)-xyzdata(2:end,1:2)).^2,2)))'];
tt=0:10:t(end);
xx=interp1(t,xyzdata(:,1),tt,'spline');
yy=interp1(t,xyzdata(:,2),tt,'spline');
img2=matline3(img,yy(1:end-1),xx(1:end-1),yy(2:end),xx(2:end),255,10);
%imshow(img2)
%WriteYaml([pathname0,filename0(1:end-4),'_remap.yaml'],imgdata);


if(remapmode ~=1)
  if isunix | ismac
      eval(['!mv ',pathname0,filename0, ' ',pathname0,filename0(1:end-3),orgdate,'.pgm'])
      eval(['!cp ',pathname0,filename0(1:end-3),'yaml', ' ',pathname0,filename0(1:end-3),orgdate,'.yaml'])
    else 
      eval(['!ren ',pathname0,filename0, ' ',filename0(1:end-3),orgdate,'.pgm'])
      eval(['!copy ',pathname0,filename0(1:end-3),'yaml', ' ',pathname0,filename0(1:end-3),orgdate,'.yaml'])
  end
  imwrite(img2,[pathname0,filename0],'PGM');
else
  if isunix | ismac
      eval(['!cp ',pathname0,filename0(1:end-3),'yaml', ' ',pathname0,filename0(1:end-4),'_remap.yaml'])
    else 
      eval(['!copy ',pathname0,filename0(1:end-3),'yaml', ' ',pathname0,filename0(1:end-4),'_remap.yaml'])
  end
      imwrite(img2,[pathname0,filename0(1:end-4),'_remap.pgm'],'PGM')
end
[row,col]=size(img);
xyzdata(:,2)=row-xyzdata(:,2);
xyzdata=xyzdata*imgdata.resolution;
xyzdata=xyzdata+repmat([imgdata.origin{1},imgdata.origin{2},imgdata.origin{3}],length(xyzdata),1);
for i=1:length(data.waypoints)
	data.waypoints(1)=[];
end
for i=1:length(xyzdata(:,1))
	data.waypoints{i}.point.x = xyzdata(i,1);
	data.waypoints{i}.point.y = xyzdata(i,2);
	data.waypoints{i}.point.z = xyzdata(i,3);
end
if(remapmode ~=1)
  if isunix | ismac
      eval(['!mv ',pathname1,filename1, ' ',pathname1,filename1(1:end-4),orgdate,'.yaml'])
    else 
      eval(['!ren ',pathname1,filename1, ' ',filename1(1:end-4),orgdate,'.yaml'])
  end
  WriteYaml([pathname1,filename1],data);
else
  WriteYaml([pathname1,filename1(1:end-5),'_remap.yaml'],data);
end

figure(2);
xyzdata=[];
for i=1:length(data.waypoints)
    xyzdata=[xyzdata;[data.waypoints{i}.point.x,data.waypoints{i}.point.y,data.waypoints{i}.point.z]];
end
fxyzdata=[data.finish_pose.pose.position.x,data.finish_pose.pose.position.y,data.finish_pose.pose.position.z];
xyzdata=xyzdata-repmat([imgdata.origin{1},imgdata.origin{2},imgdata.origin{3}],length(xyzdata),1);
fxyzdata=fxyzdata-repmat([imgdata.origin{1},imgdata.origin{2},imgdata.origin{3}],1,1);
xyzdata=xyzdata/imgdata.resolution;
fxyzdata=fxyzdata/imgdata.resolution;
[row,col]=size(img);
xyzdata(:,2)=row-xyzdata(:,2);
fxyzdata(:,2)=row-fxyzdata(:,2);
fig1=figure(2);
imshow(img2);
axis on
hold all
plot(fxyzdata(1),fxyzdata(2),'rp');axis equal
t=[0,cumsum(sqrt(sum((xyzdata(1:end-1,1:2)-xyzdata(2:end,1:2)).^2,2)))'];
tt=0:10:t(end);
xx=interp1(t,xyzdata(:,1),tt,'spline');
yy=interp1(t,xyzdata(:,2),tt,'spline');
plt1(length(data.waypoints)+1)=plot(xx,yy,'-');
for i=1:length(data.waypoints)
plt1(i)=plot(xyzdata(i,1),xyzdata(i,2),'p','markersize',10,'tag',num2str(i));
drawnow;
end
axis equal
hold off
